VERSION 5.00
Object = "{EAB22AC0-30C1-11CF-A7EB-0000C05BAE0B}#1.1#0"; "shdocvw.dll"
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form frmMain 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Microsoft MDB SQL Tester"
   ClientHeight    =   1920
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   7695
   Icon            =   "frmMain.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1920
   ScaleWidth      =   7695
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin MSComDlg.CommonDialog dlgCommon 
      Left            =   120
      Top             =   1200
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
      DefaultExt      =   "mdb"
      DialogTitle     =   "Select Database"
      Filter          =   "Access Databases (*.mdb)|*.mdb"
   End
   Begin VB.CommandButton cmdBrowse 
      Caption         =   "&Browse"
      Height          =   255
      Left            =   6600
      TabIndex        =   7
      Top             =   120
      Width           =   855
   End
   Begin SHDocVwCtl.WebBrowser webResults 
      Height          =   5535
      Left            =   960
      TabIndex        =   5
      Top             =   1920
      Width           =   6615
      ExtentX         =   11668
      ExtentY         =   9763
      ViewMode        =   0
      Offline         =   0
      Silent          =   0
      RegisterAsBrowser=   0
      RegisterAsDropTarget=   1
      AutoArrange     =   0   'False
      NoClientEdge    =   0   'False
      AlignLeft       =   0   'False
      NoWebView       =   0   'False
      HideFileNames   =   0   'False
      SingleClick     =   0   'False
      SingleSelection =   0   'False
      NoFolders       =   0   'False
      Transparent     =   0   'False
      ViewID          =   "{0057D0E0-3573-11CF-AE69-08002B2E1262}"
      Location        =   ""
   End
   Begin VB.CommandButton cmdQuery 
      Caption         =   "&Query"
      Default         =   -1  'True
      Height          =   375
      Left            =   6480
      TabIndex        =   4
      Top             =   1440
      Width           =   975
   End
   Begin VB.TextBox txtSQLQuery 
      Height          =   855
      Left            =   960
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   3
      Top             =   480
      Width           =   6495
   End
   Begin VB.TextBox txtDatabase 
      Height          =   285
      Left            =   960
      TabIndex        =   1
      Top             =   120
      Width           =   5535
   End
   Begin VB.Label Label3 
      Caption         =   "Results:"
      Height          =   255
      Left            =   120
      TabIndex        =   6
      Top             =   1920
      Width           =   735
   End
   Begin VB.Label Label2 
      Caption         =   "Query:"
      Height          =   255
      Left            =   120
      TabIndex        =   2
      Top             =   480
      Width           =   855
   End
   Begin VB.Label Label1 
      Caption         =   "Database:"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   735
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' Simple (and very quick) implementation of something to test SQL queries on a microsoft access database.
' - Performs a query and displays thwe result ina html format

Option Explicit


Private Sub cmdBrowse_Click()
    On Error GoTo CANCEL_BROWSE

    ' set up to raise an error when cancelling
    dlgCommon.CancelError = True
    ' Set to the exiting filename if it is defined
    If Len(txtDatabase.Text) > 0 Then
        dlgCommon.FileName = txtDatabase.Text
    End If
    ' Show the open panel
    dlgCommon.ShowOpen
    
    ' No error - valid file name
    txtDatabase.Text = dlgCommon.FileName
    
CANCEL_BROWSE:

End Sub

Private Sub cmdQuery_Click()
    Dim mDatabase As Database
    Dim mResults As Recordset
    Dim FileNo As Integer
    Dim Index As Integer
    
    ' Make sure a filename is specified
    If Len(txtDatabase.Text) = 0 Then
        MsgBox "Please specify a database to run the query from.", vbCritical Or vbOKOnly, "Error"
        
    ' And make sure the SQL query has something...
    ElseIf Len(txtSQLQuery.Text) = 0 Then
        MsgBox "Please specify a SQL query to perform.", vbCritical Or vbOKOnly, "Error"
        
    ' Make sure the file exists...
    ElseIf Len(Dir(txtDatabase.Text)) = 0 Then
        MsgBox "The database file specified does not exist.", vbCritical Or vbOKOnly, "Error"
        
    ' Doing well, not fully past it yet
    Else
    
        ' (try and) open the file
        On Error GoTo INVALID_DATABASE_FILE
        Set mDatabase = OpenDatabase(txtDatabase.Text, , True)
        On Error GoTo 0
        
        ' Create a new html file to write to.
        FileNo = FreeFile()
        On Error Resume Next
        Close #FileNo
        On Error GoTo 0
        
        Open App.Path & "\tmp.html" For Output As #FileNo
        
        ' Write the header information
        Print #FileNo, "<html><head>"
        ' Formatting info
        Print #FileNo, "<link rel=""StyleSheet"" type=""Text / CSS"" href=""tmp.CSS"">"
        ' Close the header
        Print #FileNo, "</head><body>"
        
        ' Perform the query
        On Error GoTo INVALID_QUERY
        Set mResults = mDatabase.OpenRecordset(txtSQLQuery.Text)
        
        ' Determine if any results exist
        If mResults.EOF = False Or mResults.BOF = False Then
            ' move to the first result
            mResults.MoveFirst
            
            ' create a table to display the results in
            Print #FileNo, "<table width=""100%""><tr>"
            
            ' Add headers to the table
            For Index = 0 To mResults.Fields.Count - 1
                Print #FileNo, "<th>" & mResults.Fields(Index).Name
            Next
            Print #FileNo, "</tr>"
            
            ' Loop round the results, writing the field values
            While Not mResults.EOF
                Print #FileNo, "<tr>"
                ' Add each value for each field in the result
                For Index = 0 To mResults.Fields.Count - 1
                    Print #FileNo, "<td>" & mResults.Fields(Index).Value
                Next
                Print #FileNo, "</tr>"
                mResults.MoveNext
            Wend
            
            ' close the table
            Print #FileNo, "</table>"
        Else
            ' Ooops
            Print #FileNo, "<p class=""Error"">No records found.</p>"
        End If
        
        
        ' close the html file
        Print #FileNo, "</body></html>"
        Close #FileNo
        
        ' Navigate to the new html file
        webResults.Navigate App.Path & "\tmp.html"
        ' Display it.
        Me.Height = 7980
        
        ' Close and delete the recordset and database
        mResults.Close
        Set mResults = Nothing
        mDatabase.Close
        Set mDatabase = Nothing
    End If

    ' Leave before the errors
    Exit Sub


INVALID_DATABASE_FILE:
    ' An error trying to load the file - let the user know
    MsgBox "The file specified cannot be opened, or is not " & vbCrLf & "a valid database file:" & vbCrLf & Err.Description, vbCritical Or vbOKOnly, "Error"
    Exit Sub
    
INVALID_QUERY:
    On Error Resume Next
    ' An error with a query...:( - let the user know
    MsgBox "Invalid Query. Windows reports this error as: " & vbCrLf & Err.Description, vbCritical Or vbOKOnly, "Error"
    Close #FileNo
End Sub

Private Sub Form_Load()
    ' Load it into memory - don't display it yet
    Load frmContents
End Sub

Private Sub Form_Unload(Cancel As Integer)
    ' Close the application - otherwise the contents panel will keep it alive
    End
End Sub

Private Sub txtDatabase_Change()
    ' Update the filename of the contents form
    If Len(txtDatabase.Text) > 0 Then
        frmContents.DatabaseFileName = txtDatabase.Text
    End If
End Sub

